#!/bin/sh
#
# Usage
#   $ binaries-ldd.sh [directory ...]
#	- find binaries (executable, libraries) and list dynamic dependencies,
#	from specified directories or the current directory.
#   $ installed-binaries-ldd.sh [basename.installed ...]
#	- find binaries (executable, libraries) and list dynamic dependencies,
#	from specified file-list files or file-list standard input.
#
# Author(s)
#   Taiji Yamada <taiji@aihara.co.jp>
#
LC_ALL=C
export LC_ALL
case "`uname -s`" in
Darwin)
  file='file -b'
  ldd='otool -L'
  ;;
SunOS|*)
  file='file'
  ldd='lddforall'
  ;;
esac

lists=false
case "`basename \"$0\"`" in
installed-*)	lists=:	;;
esac

lddforall(){
  for f in "$@"; do
    echo "$f:"
    ldd "$f"
  done
}
listup_binaries(){
  { $lists && cat "$@" || find "${@-.}" -type f; } | while read o; do
    case "$o" in
    *)
      t="`$file \"$o\"`"
      case "$t" in
      *"ELF "*" executable"*" dynamically linked"*)	;;
      *"Mach-O"*" executable"*)	;;
#      *"Mach-O"*" universal binary with"*)	;;
#      *"current ar archive"*)	;;
#      *"ar archive random library"*)	;;
      *"ELF "*" dynamic lib"*)	;;
      *"Mach-O"*" dynamically linked shared library"*)	;;
      *"Mach-O"*" bundle"*)	;;
      *) continue	;;
      esac
      ;;
    esac
    echo "$o"
  done
}
listup_binaries "$@" | while read b; do
  $ldd "$b"
done
