#!/bin/sh
#
# Usage
#   $ diffuN.sh filename~	- compare filename~ and filename files
#   $ diffuN.sh filename.org	- compare filename.org and filename files
#   $ diffuN.sh filename.orig	- compare filename.orig and filename files
#   $ diffuN.sh filename	- same above if original filename exist
#   $ diffuN.sh dirname		- find such original files and do same above
#   $ diffuN.sh arg1 arg2 ...	- native diff execution with -ru options
#
# Author(s)
#   Taiji Yamada <taiji@aihara.co.jp>
#
diff_flags=-uN
#diff_rflag=-r
diff_rflag='-r --exclude=Makefile --exclude=*.exe --exclude=*.o --exclude=*.a --exclude=*.Plo --exclude=*~ --exclude=*.org --exclude=*.orig --exclude=*.bak --exclude=*.rej --exclude=config.cache --exclude=config.status --exclude=config.h --exclude=*.log --exclude=CVS --exclude=.cvsignore --exclude=.DS_Store'

case "$#" in
1)
  if [ ! -d "$1" ]; then
    orig="$1"
    file="$1"
    case "$1" in
    *.orig)
      file=`dirname "$1"`/`basename "$1" .orig`
      ;;
    *.org)
      file=`dirname "$1"`/`basename "$1" .org`
      ;;
    *~)
      file=`dirname "$1"`/`basename "$1" '~'`
      ;;
    *)   
      [ -f "$file".orig ] && orig="$file".orig
      [ -f "$file".org ] && orig="$file".org
      [ -f "$file"'~' ] && orig="$file"'~'
      ;;
    esac
    test -r "$orig" || chmod +r "$orig"
    diff $diff_flags "$orig" "$file"
  else
    dir="$1"
    find "$dir" -name '*.orig' -o \( -name '*.org' -o -name '*~' \) -exec "$0" {} \;
  fi
  ;;
*)
  diff $diff_flags $diff_rflag "$@"
  ;;
esac
