#!/bin/sh
#
# Usage
#   $ binaries-file.sh [directory ...]
#	- find binaries (executable, libraries) and show determined file type,
#	from specified directories or the current directory.
#   $ installed-binaries-file.sh [basename.installed ...]
#	- find binaries (executable, libraries) and show determined file type,
#	from specified file-list files or file-list standard input.
#
# Author(s)
#   Taiji Yamada <taiji@aihara.co.jp>
#
LC_ALL=C
export LC_ALL
case "`uname -s`" in
Darwin)
  file='file -b'
  ;;
SunOS|*)
  file='file'
  ;;
esac

lists=false
case "`basename \"$0\"`" in
installed-*)	lists=:	;;
esac

listup_binaries(){
  { $lists && cat "$@" || find "${@-.}" -type f; } | while read o; do
    case "$o" in
    *)
      t="`$file \"$o\"`"
      case "$t" in
      *"ELF "*" executable"*)	;;
      *"Mach-O"*" executable"*)	;;
#      *"Mach-O"*" universal binary with"*)	;;
      *"current ar archive"*)	;;
      *"ar archive random library"*)	;;
      *"ELF "*" dynamic lib"*)	;;
      *"Mach-O"*" dynamically linked shared library"*)	;;
      *"Mach-O"*" bundle"*)	;;
      *) continue	;;
      esac
      ;;
    esac
    echo "$o"
  done
}
listup_binaries "$@" | while read b; do
  file "$b"
done
