#!/bin/sh
#
# Usage
#   $ installed-differ-removed.sh uninstalled installed
#	- show removed files in differences between uninstalled installed
#   $ installed-differ-added.sh uninstalled installed
#	- show added files in differences between uninstalled installed
#
#   $ uninstall-differ-removed-tbz2.sh uninstalled installed
#	- archive removed files in differences between uninstalled installed
#   $ uninstall-differ-removed-tgz.sh uninstalled installed
#	- archive removed files in differences between uninstalled installed
#   $ uninstall-differ-removed-txz.sh uninstalled installed
#	- archive removed files in differences between uninstalled installed
#
codename=${CODENAME:-`uname -n | sed -ne 's/\([^.]*\).*/\1/p' | tr A-Z a-z`}
type=removed
while true; do case "$1" in
-s) sudo=sudo	;;
-C) shift; destdir="$1"	;;
*) break	;;
esac; shift; done

case $# in
2);;
*)
  echo "`basename $0` [-s] [-C destdir] basename.installed basename2.installed"
  exit
  ;;
esac

listup(){
  case $type in
  removed)	grep '^-[^-]' | sed 's|^-||' | grep -v '/$';;
  added|*)	grep '^+[^+]' | sed 's|^+||' | grep -v '/$';;
  esac
}
case `basename $0 .sh` in
*-removed*)	type=removed;;
*-added*|*)	type=added;;
esac

case `basename $0 .sh` in
*-tgz)
  ar_sh=-tgz.sh
  ;;
*-tbz2)
  ar_sh=-tbz2.sh
  ;;
*-txz)
  ar_sh=-txz.sh
  ;;
esac

if [ "$ar_sh" != "" ]; then
  list="`basename \"$1\" .installed`"
  list="`basename \"$list\" .uninstalled`"
  list="`basename \"$list\" -$codename`"
  list="$list--`basename \"$2\" .installed`"
  list="`basename \"$list\" -$codename`"
  list="$list-$type-$codename.installed"
  case `basename $0 .sh` in
  uninstall-*)
    ar_sh="uninstall$ar_sh"
    ;;
  *)
    ar_sh="installed$ar_sh"
  esac
fi

keep_file(){
  keep_file="$1"
  kept_file=
  if [ -f "$keep_file" ]; then
    kept_file="${keep_file}~"
    while [ -f "$kept_file" ]; do kept_file="${kept_file}~"; done
    echo "mv $keep_file $kept_file"
    mv "$keep_file" "$kept_file"
  fi
}

[ "$list" != "" ] && {
  keep_file "$list"
  diff -u "$1" "$2" | listup | tee "$list"
  [ -f "$kept_file" ] && cmp "$kept_file" "$list" > /dev/null 2>&1 && mv -f "$kept_file" "$list"
  [ "$ar_sh" != "" ] && $ar_sh ${sudo:+-s} ${destdir:+-C "$destdir"} "$list"
} || {
  diff -u "$1" "$2" | listup
}
