#!/bin/sh
#
# Usage
#   $ installed-exclude-tbz2.sh [-s] [-C destdir]
#	- archive files excluded by make-installed.sh
#
codename=${CODENAME:-`uname -n | sed -ne 's/\([^.]*\).*/\1/p' | tr A-Z a-z`}
while true; do case "$1" in
-s) sudo=sudo	;;
-C) shift; destdir="$1" ;;
*) break	;;
esac; shift; done

case `basename $0 .sh` in
*-tgz)
  AR=tar
  FILTER=gzip
  SUF=.tar.gz
  ;;
*-tbz2)
  AR=tar
  FILTER=bzip2
  SUF=.tar.bz2
  ;;
*-txz)
  AR=tar
  FILTER=xz
  SUF=.tar.xz
  ;;
esac

keep_file(){
  keep_file="$1"
  kept_file=
  if [ -f "$keep_file" ]; then
    kept_file="${keep_file}~"
    while [ -f "$kept_file" ]; do kept_file="${kept_file}~"; done
    echo "mv $keep_file $kept_file"
    mv "$keep_file" "$kept_file"
  fi
}

archive="exclude-`date +'%Y%m%d'`-$codename-binaries$SUF"
keep_file "$archive"
echo "$sudo $AR -cvf - \`find /usr/local/* /opt/local/* \( -regex '.*/info/dir$' -o -name charset.alias -o -name locale.alias \) ! -type d\` | $FILTER > $archive"
$sudo $AR -cvf - `find /usr/local/* /opt/local/* \( -regex '.*/info/dir$' -o -name charset.alias -o -name locale.alias \) ! -type d` | $FILTER > "$archive"
[ -f "$kept_file" ] && cmp "$kept_file" "$keep_file" > /dev/null 2>&1 && mv -f "$kept_file" "$keep_file"
