#!/bin/sh

local=${LOCAL:-/opt/local}
x_top=${X_TOP:-/usr/X11R6}
x_etc=${X_ETC:-/etc/X11}
codename=${CODENAME:-`uname -n | sed -ne 's/\([^.]*\).*/\1/p' | tr A-Z a-z`}

pwd=`pwd`
basename=`basename "$pwd"`
varlisted="$basename-$codename.varlisted"
admlisted="$basename-$codename.admlisted"
syslisted="$basename-$codename.syslisted"
x11listed="$basename-$codename.x11listed"
diflisted="$basename-$codename.diflisted"

cat <<EOF > $varlisted
$local/etc/ebnetd.conf
`find $local/lib/wnn/ja_JP/dic/usr ! -type d -print`
`find $local/canna/share/canna/dic/user ! -type d -print`
EOF
find_extra_args='! -regex .*/info/dir$ ! -name charset.alias ! -name locale.alias'
find $local $x_top $x_etc ! -type d ! \( $find_extra_args \) -print >> $varlisted

(cat $varlisted; find . -name "*-$codename.installed" -exec cat {} \;) | sort > $admlisted

find $local $x_top $x_etc ! -type d -print | sort > $syslisted

([ -f $x11listed ] && cat $admlisted $x11listed | sort || cat $admlisted) | diff - $syslisted | tee $diflisted | ${PAGER:-less}
